﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.UltraChart;
using Infragistics.UltraChart.Shared.Events;
using Infragistics.UltraChart.Core.Primitives;
using System.Drawing;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        UltraChart1.DataSource = GetColumnData();
        UltraChart1.DataBind();
    }

    protected void UltraChart1_FillSceneGraph(object sender, FillSceneGraphEventArgs e)
    {
        foreach (Primitive p in e.SceneGraph)
        {
            if (p is Wedge)
            {
                // Create the color image that shows before the legend item
                Bitmap colorBitmap = new Bitmap(10, 10);
                Graphics g = Graphics.FromImage(colorBitmap);
                SolidBrush brush = new SolidBrush(p.PE.Fill);
                g.FillRectangle(brush, 0, 0, 10, 10);
                string colorPath = "ChartImages/" + p.DataPoint.Label + ".jpg";
                colorBitmap.Save(Server.MapPath(colorPath));
                System.Web.UI.WebControls.Image colorBox = new System.Web.UI.WebControls.Image();
                colorBox.ImageUrl = colorPath;

                TableCell labelCell = new TableCell();
                // Create the label for the legend item
                Label legendText = new Label();
                legendText.Text = p.DataPoint.Label;
                labelCell.Controls.Add(legendText);

                // Add the legend item components to a new row in the table
                TableCell colorCell = new TableCell();
                colorCell.Controls.Add(colorBox);

                TableRow r = new TableRow();
                r.Cells.Add(colorCell);
                r.Cells.Add(labelCell);

                Table1.Rows.Add(r);
            }
        }
    }

    private DataTable GetColumnData()
    {
        DataTable mydata = new DataTable();
        // Define the columns and their names
        mydata.Columns.Add("Labels", typeof(string));
        mydata.Columns.Add("Data", typeof(int));
        // Add the rows of data
        for (int i = 0; i < 25; i++)
        {
            mydata.Rows.Add(new Object[] { "Item" + i, i + 1 });
        }
        return mydata;
    }
}
